\documentclass{standalone}
\usepackage{tikz}
\usetikzlibrary[patterns]
\begin{document}
\begin{tikzpicture}
  % E
  \draw[dashed] (0,0) rectangle (2,2);
  % B
  \filldraw[fill=gray!30] (1.3,0) -- (1.3,2) -- (0,2) -- (0,0) -- cycle;
  % A
  \draw[dashed] (0,0.5) -- (2,1) -- (2,2) -- (0,2) -- cycle;
  % B cond A
  \clip (0,0.5) -- (2,1) -- (2,2) -- (0,2) -- cycle;
  \clip (1.3,0) -- (1.3,2) -- (0,2) -- (0,0) -- cycle;
  \fill[pattern=vertical lines] (0,0) rectangle (3,3);

\end{tikzpicture}
\end{document}
